/* ----------------------------------
8051 DEMO Code
Color LCD - TFT 3.2"
16 Bit Parallel Interface, On board ILI9341 Controller, Touch Screen
Model# 4619
Web: http://www.sunrom.com/m/4619
----------------------------------*/

#include <reg51.h>
#include <intrins.h>
#include <sys\sys.h>
#include <lcd\lcd.h>
#include <font\font.h>
#include <touch\touch.h>

/* 
Target: Any 3.3V operated 8051 MCU
8051 Connection for this code
RS-P3^5;    WR-P3^6;   RD-P3^7;   CS-P1^0;   REST-P1^2;
DB0-DB7=P0^0-P0^7;  
DB8-DB15=P2^0-P2^7;
T_CLK-P1^7;  T_CS-P1^4;  T_DIN-P3^0;  T_OUT-P3^1;  T_IRQ-P3^4;
*/	
sbit key1=P3^2;
sbit key2=P3^3;
sbit key3=P3^4;
u8 ref=0;

u8 check()
{
	if (tpstate()==0)
	 {
	 	LCD_Clear(WHITE);
		BACK_COLOR=WHITE;
		POINT_COLOR=RED;
	 	point();
		return 1;
	 }	
	if(key1==0)	
	   {
		Touch_Adjust();
		return 1;
	   }
	 if(key2==0)	
	   {
		 LCD_Clear(RED);
		 delayms(3000);
		 LCD_Clear(GREEN);
		 delayms(3000);
		 LCD_Clear(BLUE);
		 delayms(3000);
		 return 1;
	   }
	   return 0;
}
void string_show()
{   
	u16 lx,ly;
	BACK_COLOR=WHITE;
	POINT_COLOR=RED;	
	showhanzi(10,0,0);  
	showhanzi(45,0,1);  
  LCD_ShowString(10,35,"http://WWW.SUNROM.COM");
	LCD_ShowString(10,55,"LCD_W:");	LCD_ShowNum(70,55,LCD_W,3);
	LCD_ShowString(110,55,"LCD_H:");LCD_ShowNum(160,55,LCD_H,3);	
	lx=10;ly=75;			
	LCD_ShowString(lx,ly,"VX:");lx+=40;LCD_ShowNum(lx,ly,vx,5);					
	lx+=60;
	LCD_ShowString(lx,ly,"Vy:");lx+=40;LCD_ShowNum(lx,ly,vy,5);					
	lx=10;ly=95; 
	LCD_ShowString(lx,ly,"CHX:");lx+=40;LCD_ShowNum(lx,ly,chx,5);					
	lx+=60; 
	LCD_ShowString(lx,ly,"CHY:");lx+=40;LCD_ShowNum(lx,ly,chy,5);
}
void showimage() 
{
  int i,j,k; 
	LCD_Clear(WHITE); 
	string_show(); 
	for(k=3;k<8;k++)
	{
	   	for(j=0;j<6;j++)
		{	
			Address_set(40*j,40*k,40*j+39,40*k+39);		
		    for(i=0;i<1600;i++)
			 { 	
				 if(check()) 
				 {	
				 	ref=1;
				  	return;	
				 }		
			  	 LCD_WR_DATA8(image[i*2+1],image[i*2]);	   						
			 }	
		 }
	}
	ref=0;				
}
/* ----------------------------------
8051 DEMO Code
Color LCD - TFT 3.2"
16 Bit Parallel Interface, 
On board ILI9341 Controller, Touch Screen
Model# 4619
Web: http://www.sunrom.com/m/4619
----------------------------------*/
void main()
{ 
	spistar();
	Lcd_Init();   //ILI9341 Init
	
	LCD_Clear(WHITE); 
	BACK_COLOR=BLACK;;POINT_COLOR=WHITE; 
	
  showimage(); 
	while(1)
	{
		if(check()) 
	  {	
	  	showimage(); 
	  }
	  if(ref){showimage();} 

  }
}
